
; CC5X Version 3.1G, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  15. Jul 2003  15:38  *************

	processor  16F84
	radix  DEC

PCL         EQU   0x02
STATUS      EQU   0x03
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
INTF        EQU   1
T0IF        EQU   2
OPTION_REG  EQU   0x81
titim       EQU   0x15
tisig       EQU   0x16
ti1         EQU   0x17
timax       EQU   0x18
timin       EQU   0x19
tisimax     EQU   0x1A
tisimin     EQU   0x1B
te1         EQU   0x1C
tesig       EQU   0x1D
temax       EQU   0x1E
temin       EQU   0x1F
tesimax     EQU   0x20
tesimin     EQU   0x21
timinter    EQU   0x22
timminmax   EQU   0x23
tim5ms      EQU   0x24
tim128      EQU   0x25
timaf       EQU   0x26
afeta       EQU   0x27
tempsig     EQU   0x28
tempdix     EQU   0x29
tempuni     EQU   0x2A
tempdiz     EQU   0x2B
intext      EQU   0
dq          EQU   1
clk         EQU   2
rst         EQU   3
minmax      EQU   4
aft         EQU   1
LCD_RS      EQU   2
LCD_EN      EQU   3
LCD_D4      EQU   4
LCD_D5      EQU   5
s1          EQU   0x0C
s2          EQU   0x0D
c           EQU   0x0E
fin         EQU   0x0F
c_2         EQU   0x13
cpt         EQU   0x14
c_3         EQU   0x12
s           EQU   0x0E
c_4         EQU   0x11
pos         EQU   0x11
pos_2       EQU   0x0E
nb          EQU   0x0F
nb_2        EQU   0x0E
valeur      EQU   0x0E
signe       EQU   0x0F
cpt_2       EQU   0x10
ci          EQU   0x0F

	GOTO main

  ; FILE C:\MESDOC~1\HERVE\MPLAB\THERMO~1\THERMORE.C
			;
			;// Thermomtre avec temprature intrieure et extrieure.
			;// Quartz  3.2768Mhz
			;// prdiviseur  16, incrmentation de RTCC toute les 19.53us dbordement toute les 5ms
			;// Affichage sur un LCD 1 ligne.
			;// Traitement de l'inter toute les 5ms
			;// traitement de la temprature intrieure toute les 12.8s
			;// Reception de la temprature extrieure par interruption
			; 
			;#include "16f84.h"
			;#include "int16CXX.H"
			;
			;
			;
			;//---------------------------Constantes----------------------------------
			;
			;#define	cid	0b00000110;	// adresse de la carte capteur externe
			;
			;#define	clong	10		// constante  12.8s
			;#define	ctrtim	41		// fin timer transmission front montant il y a 800us
			;#define	ctrerr	87		// fin timer erreur front montant il y a 1700us
			;#define	cinatt	60		// attente avant nouvelle scrutation clavier 300ms
			;
			;//---------------------------Variables globales---------------------------------------
			;
			;// Temprature interieure
			;char 	titim;		// timer pour commencer la rcupration
			;char	tisig;		// signe - ou rien
			;char 	ti1;		// valeur de la temprature intrieure
			;char	timax;		// temprature intrieure max
			;char	timin;		// temprature intrieure min
			;char	tisimax;	// signe de la temprature max
			;char	tisimin;	// Signe de la temprature min
			;
			;// Temprature extrieure
			;char 	te1;		// valeur de la temp extrieure
			;char	tesig;		// signe - ou rien
			;char	temax;		// temprtature extrieure max
			;char	temin;		// tempraturez extrieure min
			;char	tesimax;	// signe de la temprature max
			;char	tesimin;	// Signe de la temprature min
			;
			;// transmission radio
			;
			;// Affichage et timer
			;char	timinter;	// timer de scrutation de l'interrupteur
			;char    timminmax;	// determination de lappui long sur l'interrupteur minmax
			;char	tim5ms;		// compteur des 5ms, dbordement toutes les 1.28s
			;char	tim128;		// compteur des 1.28s
			;char	timaf;		// timer d'affichage
			;char	afeta;		// etat de l'affichage
			;                              	// 7
			;				// 6
			;				// 5
			;				// 4  affichage valide
			;				// 3  affichage temp ext=1  int=0
			;				// 2  affichage du minimum
			;				// 1  affichage du maximum
			;				// 0  affichage du present
			;char	tempsig;	// signe  afficher
			;char	tempdix;	// diximes  afficher
			;char	tempuni;	// unites  afficher
			;char	tempdiz;	// dizaines  afficher
			;
			;//------------------------I/O-------------------------------------------
			;
			;bit	intext @ PORTA.0;	// interrupteur intrieur exterieur
			;bit	dq @ PORTA.1;		// temprature intrieure I/O
			;bit	clk @ PORTA.2;		// horloge temprature interieure
			;bit 	rst @ PORTA.3;		// temprature interieure reset
			;bit	minmax @ PORTA.4;	// interrupteur min, max, mormal
			;bit	te @ PORTB.0;		// temprature exterieure
			;bit	aft @ PORTB.1;		// affichage sous tension
			;bit	LCD_RS @ PORTB.2;	// register select de l'afficheur
			;bit	LCD_EN @ PORTB.3;	// enable de l'afficheur
			;bit	LCD_D4 @ PORTB.4;
			;bit	LCD_D5 @ PORTB.5;
			;
			;
			;
			;//-------------------------equivalence-----------------------------------
			;
			;#define	sortie	TRISA=0b00010001;	// sens des broches porta avec dq en sortie
			;#define	entree	TRISA=0b00010011;	// sens des broches porta avec dq en entree
			;
			;//--------------------------------interruption----------------------------
			;
			;#pragma origin 4
	ORG 0x0004
			;
			;
			;
			;interrupt interruption(void)
			;{
interruption
			;int_save_registers
	MOVWF s1
	SWAPF STATUS,W
	MOVWF s2
			;
			;  if (T0IF)			// interruption timer
	BTFSS 0x0B,T0IF
	GOTO  m002
			;  {
			;  tim5ms++;			// incrementation timer 5ms
	INCF  tim5ms,1
			;  timinter++;			// incrementation du timer pour la gestion de l'interrupteur
	INCF  timinter,1
			;  if (tim5ms==0)		// 1.28 seconde atteint
	MOVF  tim5ms,1
	BTFSS 0x03,Zero_
	GOTO  m001
			;    { 
			;
			;	titim++;				// incrementation timer de rcupration de t interieure
	INCF  titim,1
			;	tim128++;				// incrementation timer 1.28s
	INCF  tim128,1
			;	timaf++;				// incrementation timer d'affichage
	INCF  timaf,1
			;	if (timaf==clong)			// eteindre l'affichage au bout de clong secondes
	MOVF  timaf,W
	XORLW .10
	BTFSS 0x03,Zero_
	GOTO  m001
			;		{
			;		aft=1;
	BCF   0x03,RP0
	BSF   0x06,aft
			;		afeta.4=0;
	BCF   afeta,4
			;		}
			;    }
			;  T0IF = 0; 
m001	BCF   0x0B,T0IF
			;  }
			;
			;  if (INTF)			// interruption RB0
m002	BTFSC 0x0B,INTF
			;  {
			;  INTF = 0;
	BCF   0x0B,INTF
			;  }
			;
			;int_restore_registers
	SWAPF s2,W
	MOVWF STATUS
	SWAPF s1,1
	SWAPF s1,W
			;}
	RETFIE
			;
			;//-------------------initialisation-------------------------------------
			;
			;void initialisation()
			;{
_const1
	MOVWF ci
	MOVLW .91
	SUBWF ci,W
	BTFSC 0x03,Carry
	RETLW .0
	CLRF  PCLATH
	MOVF  ci,W
	ADDWF PCL,1
	RETLW .4
	RETLW .10
	RETLW .17
	RETLW .31
	RETLW .17
	RETLW .21
	RETLW .31
	RETLW .0
	RETLW .14
	RETLW .31
	RETLW .31
	RETLW .14
	RETLW .20
	RETLW .13
	RETLW .6
	RETLW .0
	RETLW .24
	RETLW .24
	RETLW .3
	RETLW .4
	RETLW .4
	RETLW .4
	RETLW .3
	RETLW .0
	RETLW .8
	RETLW .28
	RETLW .8
	RETLW .0
	RETLW .1
	RETLW .32
	RETLW .32
	RETLW .45
	RETLW .45
	RETLW .44
	RETLW .45
	RETLW .3
	RETLW .0
	RETLW .1
	RETLW .5
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .44
	RETLW .32
	RETLW .3
	RETLW .0
	RETLW .2
	RETLW .5
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .44
	RETLW .32
	RETLW .3
	RETLW .0
	RETLW .1
	RETLW .4
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .44
	RETLW .32
	RETLW .3
	RETLW .0
	RETLW .2
	RETLW .4
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .44
	RETLW .32
	RETLW .3
	RETLW .0
	RETLW .1
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .44
	RETLW .32
	RETLW .3
	RETLW .0
	RETLW .2
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .32
	RETLW .44
	RETLW .32
	RETLW .3
	RETLW .0
initialisation
			;OPTION=0b11010011;	// registre option    prediv=16
	MOVLW .211
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;PORTA=0b00010100;	// porta  l'initialisation
	MOVLW .20
	BCF   0x03,RP0
	MOVWF PORTA
			;PORTB=0b00000010;	// portb  l'initialisation
	MOVLW .2
	MOVWF PORTB
			;sortie
	MOVLW .17
	BSF   0x03,RP0
	MOVWF TRISA
			;TRISB=0b00000001;	// sens des broches portb
	MOVLW .1
	MOVWF TRISB
			;INTCON=0b10110000;	// autorisation des interruptions
	MOVLW .176
	MOVWF INTCON
			;tim5ms=0;
	CLRF  tim5ms
			;tim128=0;
	CLRF  tim128
			;afeta=0b00010001;	// initialisation de l'affichage
	MOVLW .17
	MOVWF afeta
			;timaf=0;
	CLRF  timaf
			;titim=30;		// initialisation des tempratures
	MOVLW .30
	MOVWF titim
			;tisimax='-';
	MOVLW .45
	MOVWF tisimax
			;timax=0x92;
	MOVLW .146
	MOVWF timax
			;tisimin=' ';
	MOVLW .32
	MOVWF tisimin
			;timin=0xFA;
	MOVLW .250
	MOVWF timin
			;tesig=' ';
	MOVLW .32
	MOVWF tesig
			;te1=0xFA;
	MOVLW .250
	MOVWF te1
			;tesimax='-';
	MOVLW .45
	MOVWF tesimax
			;temax=0x92;
	MOVLW .146
	MOVWF temax
			;tesimin=' ';
	MOVLW .32
	MOVWF tesimin
			;temin=0xFA;
	MOVLW .250
	MOVWF temin
			;
			;}
	RETURN
			;
			;//-------------------------delay en 5ms-----------------------------------
			;
			;void delay_5ms(char c)
			;{
delay_5ms
	MOVWF c
			;char fin;
			;fin = c + tim5ms;
	MOVF  tim5ms,W
	ADDWF c,W
	MOVWF fin
			;do clrwdt(); while(tim5ms != fin);
m003	CLRWDT
	MOVF  tim5ms,W
	XORWF fin,W
	BTFSS 0x03,Zero_
	GOTO  m003
			;}
	RETURN
			;//-------------------------delay en 20us-----------------------------------
			;
			;void delay_10us(char c)
			;{
delay_10us
	MOVWF c_2
			;char cpt;
			;cpt = 0 ;
	CLRF  cpt
			;do
			; {
			;  nop();
m004	NOP  
			;  nop();
	NOP  
			;  nop();
	NOP  
			;  clrwdt();
	CLRWDT
			;  cpt++;
	INCF  cpt,1
			; }
			;while(cpt != c);
	MOVF  cpt,W
	XORWF c_2,W
	BTFSS 0x03,Zero_
	GOTO  m004
			;}
	RETURN
			;
			;//--------------------------------crire en code rduit---------------------------------
			;//	LCD_D4 = PORTB.4    LCD_D5 = PORTB.5  etc
			;
			;void lcd_write_fast(unsigned char c)
			;{
lcd_write_fast
	MOVWF c_3
			;
			;	PORTB &= 0b00001111;	// RB4  RB7 = 0
	MOVLW .15
	BCF   0x03,RP0
	ANDWF PORTB,1
			;	W = c & 0b11110000;
	MOVLW .240
	ANDWF c_3,W
			;	PORTB |= W; 		//quartet haut de c sur RB4  RB7
	IORWF PORTB,1
			;	LCD_EN = 1;
	BSF   0x06,LCD_EN
			;	LCD_EN = 0;
	BCF   0x06,LCD_EN
			;	PORTB &= 0b00001111;	// RB4  RB7 = 0
	MOVLW .15
	ANDWF PORTB,1
			;	c = swap (c);
	SWAPF c_3,1
			;	W = c & 0b11110000;
	MOVLW .240
	ANDWF c_3,W
			;	PORTB |= W; 		//quartet haut de c sur RB4  RB7
	IORWF PORTB,1
			;	LCD_EN = 1;
	BSF   0x06,LCD_EN
			;	LCD_EN = 0;
	BCF   0x06,LCD_EN
			;	delay_10us(8);
	MOVLW .8
	GOTO  delay_10us
			;}
			;
			;//-------------------------------Clear and home the LCD---------------------------------
			;
			;void lcd_clear(void)
			;{
lcd_clear
			;	LCD_RS = 0;
	BCF   0x03,RP0
	BCF   0x06,LCD_RS
			;        lcd_write_fast(0x1);
	MOVLW .1
	CALL  lcd_write_fast
			;	delay_5ms(1);
	MOVLW .1
	GOTO  delay_5ms
			;}
			;
			;//----------------------write a string of chars to the LCD-------------------------------
			;
			;void lcd_puts(const char * s)
			;{
lcd_puts
			;	LCD_RS = 1;		// write characters
	BCF   0x03,RP0
	BSF   0x06,LCD_RS
			;	while(*s) lcd_write_fast(*s++);
m005	MOVF  s,W
	CALL  _const1
	XORLW .0
	BTFSC 0x03,Zero_
	GOTO  m006
	MOVF  s,W
	CALL  _const1
	CALL  lcd_write_fast
	INCF  s,1
	GOTO  m005
			;}
m006	RETURN
			;
			;//---------------------------write one character to the LCD--------------------------------
			;
			;void lcd_putch(unsigned char c)
			;{
lcd_putch
	MOVWF c_4
			;	LCD_RS = 1;		// write characters
	BCF   0x03,RP0
	BSF   0x06,LCD_RS
			;	lcd_write_fast(c);
	MOVF  c_4,W
	GOTO  lcd_write_fast
			;}
			;
			;//---------------------------Go to the specified position----------------------------------
			;
			;void lcd_goto(unsigned char pos)
			;{
lcd_goto
	MOVWF pos
			;	LCD_RS = 0;
	BCF   0x03,RP0
	BCF   0x06,LCD_RS
			;	lcd_write_fast(0x80 + pos);
	MOVLW .128
	ADDWF pos,W
	GOTO  lcd_write_fast
			;}
			;
			;
			;//-------------------------Go to specific position to program caracter---------------------
			;
			;void lcd_goto_cgram(unsigned char pos)
			;{
lcd_goto_cgram
	MOVWF pos_2
			;	LCD_RS = 0;
	BCF   0x03,RP0
	BCF   0x06,LCD_RS
			;	lcd_write_fast(0x40 + pos);
	MOVLW .64
	ADDWF pos_2,W
	GOTO  lcd_write_fast
			;}
			;
			;
			;//--------------------initialise the LCD - put into 4 bit mode-------------------------
			;
			;void lcd_init(void)
			;{
lcd_init
			;	LCD_RS = 0;		// write control bytes
	BCF   0x03,RP0
	BCF   0x06,LCD_RS
			;	delay_5ms(5);		// power on delay
	MOVLW .5
	CALL  delay_5ms
			;	LCD_D4 = 1;		// init!
	BSF   0x06,LCD_D4
			;	LCD_D5 = 1;
	BSF   0x06,LCD_D5
			;	LCD_EN = 1;
	BSF   0x06,LCD_EN
			;	LCD_EN = 0;	
	BCF   0x06,LCD_EN
			;	delay_5ms(3);
	MOVLW .3
	CALL  delay_5ms
			;	LCD_EN = 1;		// init!
	BSF   0x06,LCD_EN
			;	LCD_EN = 0;	
	BCF   0x06,LCD_EN
			;	delay_10us(14);
	MOVLW .14
	CALL  delay_10us
			;	LCD_EN = 1;		// init!
	BSF   0x06,LCD_EN
			;	LCD_EN = 0;	
	BCF   0x06,LCD_EN
			;	delay_5ms(3);
	MOVLW .3
	CALL  delay_5ms
			;	LCD_D4 = 0;		// set 4 bit mode
	BCF   0x06,LCD_D4
			;	LCD_EN = 1;
	BSF   0x06,LCD_EN
			;	LCD_EN = 0;	
	BCF   0x06,LCD_EN
			;	delay_10us(8);
	MOVLW .8
	CALL  delay_10us
			;	lcd_write_fast(0x28);	// 4 bit mode, 1/16 duty, 5x8 font, 2 lines
	MOVLW .40
	CALL  lcd_write_fast
			;	lcd_write_fast(0x0C);	// display on
	MOVLW .12
	CALL  lcd_write_fast
			;	lcd_write_fast(0x06);	// entry mode advance cursor
	MOVLW .6
	CALL  lcd_write_fast
			;	lcd_write_fast(0x01);	// clear display and reset cursor
	MOVLW .1
	CALL  lcd_write_fast
			;	delay_5ms(1);
	MOVLW .1
	GOTO  delay_5ms
			;}
			;
			;//--------------------criture de 8 bit sur le ds1620--------------------
			;
			;void temp_write_8bits(unsigned char nb)
			;{
temp_write_8bits
	MOVWF nb
			;sortie
	MOVLW .17
	BSF   0x03,RP0
	MOVWF TRISA
			;clk=0;				// criture de nb dans ds1620
	BCF   0x03,RP0
	BCF   0x05,clk
			;dq=nb.0;
	BTFSS nb,0
	BCF   0x05,dq
	BTFSC nb,0
	BSF   0x05,dq
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;dq=nb.1;
	BTFSS nb,1
	BCF   0x05,dq
	BTFSC nb,1
	BSF   0x05,dq
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;dq=nb.2;
	BTFSS nb,2
	BCF   0x05,dq
	BTFSC nb,2
	BSF   0x05,dq
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;dq=nb.3;
	BTFSS nb,3
	BCF   0x05,dq
	BTFSC nb,3
	BSF   0x05,dq
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;dq=nb.4;
	BTFSS nb,4
	BCF   0x05,dq
	BTFSC nb,4
	BSF   0x05,dq
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;dq=nb.5;
	BTFSS nb,5
	BCF   0x05,dq
	BTFSC nb,5
	BSF   0x05,dq
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;dq=nb.6;
	BTFSS nb,6
	BCF   0x05,dq
	BTFSC nb,6
	BSF   0x05,dq
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;dq=nb.7;
	BTFSS nb,7
	BCF   0x05,dq
	BTFSC nb,7
	BSF   0x05,dq
			;clk=1;
	BSF   0x05,clk
			;}
	RETURN
			;
			;//--------------------lecture de 8 bits sur le ds1620---------------------
			;
			;void temp_read_8bits(void)
			;{
temp_read_8bits
			;
			;entree
	MOVLW .19
	BSF   0x03,RP0
	MOVWF TRISA
			;clk=0;
	BCF   0x03,RP0
	BCF   0x05,clk
			;ti1.0=dq;
	BCF   ti1,0
	BTFSC 0x05,dq
	BSF   ti1,0
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;ti1.1=dq;
	BCF   ti1,1
	BTFSC 0x05,dq
	BSF   ti1,1
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;ti1.2=dq;
	BCF   ti1,2
	BTFSC 0x05,dq
	BSF   ti1,2
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;ti1.3=dq;
	BCF   ti1,3
	BTFSC 0x05,dq
	BSF   ti1,3
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;ti1.4=dq;
	BCF   ti1,4
	BTFSC 0x05,dq
	BSF   ti1,4
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;ti1.5=dq;
	BCF   ti1,5
	BTFSC 0x05,dq
	BSF   ti1,5
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;ti1.6=dq;
	BCF   ti1,6
	BTFSC 0x05,dq
	BSF   ti1,6
			;clk=1;
	BSF   0x05,clk
			;clk=0;
	BCF   0x05,clk
			;ti1.7=dq;
	BCF   ti1,7
	BTFSC 0x05,dq
	BSF   ti1,7
			;clk=1;
	BSF   0x05,clk
			;}
	RETURN
			;
			;//-------------------------ecriture de la config dans le ds1620-------------------------
			;void temp_cfg_write(char nb)		// le temps d'criture prend 10 ms
			;{
temp_cfg_write
	MOVWF nb_2
			;rst=1;
	BCF   0x03,RP0
	BSF   0x05,rst
			;temp_write_8bits(0x0C);
	MOVLW .12
	CALL  temp_write_8bits
			;temp_write_8bits(nb);
	MOVF  nb_2,W
	CALL  temp_write_8bits
			;rst=0;
	BCF   0x03,RP0
	BCF   0x05,rst
			;}
	RETURN
			;
			;//-------------------------start conversion du ds1620-------------------------
			;void temp_start(void)
			;{
temp_start
			;rst=1;
	BCF   0x03,RP0
	BSF   0x05,rst
			;temp_write_8bits(0xEE);
	MOVLW .238
	CALL  temp_write_8bits
			;rst=0;
	BCF   0x03,RP0
	BCF   0x05,rst
			;}
	RETURN
			;
			;
			;//-------------------------lecture de la temprature du ds1620 et traitement du max et min-------------
			;void temp_read(void)
			;
			;{
temp_read
			;rst=1;				//recuperation dans ti1 de la temprature
	BCF   0x03,RP0
	BSF   0x05,rst
			;temp_write_8bits(0xAA);
	MOVLW .170
	CALL  temp_write_8bits
			;temp_read_8bits();
	CALL  temp_read_8bits
			;clk=0;				//reception du signe de la temprature et traitement du min et max
	BCF   0x03,RP0
	BCF   0x05,clk
			;if(dq==0)
	BTFSC 0x05,dq
	GOTO  m009
			;   {
			;	clk=1;		// temperature>0
	BSF   0x05,clk
			;	rst=0;
	BCF   0x05,rst
			;	tisig=' ';
	MOVLW .32
	MOVWF tisig
			;	if (tisimax=='-')
	MOVF  tisimax,W
	XORLW .45
	BTFSS 0x03,Zero_
	GOTO  m007
			;	  {
			;	   tisimax=' ';
	MOVLW .32
	MOVWF tisimax
			;	   timax=ti1;
	MOVF  ti1,W
	MOVWF timax
			;	  }
			;	else if (ti1>timax) timax=ti1;
	GOTO  m008
m007	MOVF  ti1,W
	SUBWF timax,W
	BTFSC 0x03,Carry
	GOTO  m008
	MOVF  ti1,W
	MOVWF timax
			;	if (tisimin==' ')
m008	MOVF  tisimin,W
	XORLW .32
	BTFSS 0x03,Zero_
	GOTO  m012
			;	  {
			;	   if (ti1<timin) timin=ti1;
	MOVF  timin,W
	SUBWF ti1,W
	BTFSC 0x03,Carry
	GOTO  m012
	MOVF  ti1,W
	MOVWF timin
			;	  }
			;   }
			;else
	GOTO  m012
			;   {
			;	clk=1; 		// temperature<0
m009	BCF   0x03,RP0
	BSF   0x05,clk
			;	rst=0;
	BCF   0x05,rst
			;	tisig='-';
	MOVLW .45
	MOVWF tisig
			;	if (tisimin==' ')
	MOVF  tisimin,W
	XORLW .32
	BTFSS 0x03,Zero_
	GOTO  m010
			;	  {
			;	   tisimin='-';
	MOVLW .45
	MOVWF tisimin
			;	   timin=ti1;
	MOVF  ti1,W
	MOVWF timin
			;	  }
			;	else if (ti1<timin) timin=ti1;
	GOTO  m011
m010	MOVF  timin,W
	SUBWF ti1,W
	BTFSC 0x03,Carry
	GOTO  m011
	MOVF  ti1,W
	MOVWF timin
			;	if (tisimax=='-')
m011	MOVF  tisimax,W
	XORLW .45
	BTFSS 0x03,Zero_
	GOTO  m012
			;	  {
			;	   if (ti1>timax) timax=ti1;
	MOVF  ti1,W
	SUBWF timax,W
	BTFSC 0x03,Carry
	GOTO  m012
	MOVF  ti1,W
	MOVWF timax
			;	  }
			;   }
			;
			;}
m012	RETURN
			;//---------------------------conversion de la temprature en dizaine unite dixime et affichage-------------
			;
			;void affichage(char valeur, char signe)
			;{
affichage
	MOVWF signe
			;char cpt;
			;
			;     if(valeur.0 ==0) tempdix='0'; else tempdix='5';	// ecriture des diximes.
	BTFSC valeur,0
	GOTO  m013
	MOVLW .48
	MOVWF tempdix
	GOTO  m014
m013	MOVLW .53
	MOVWF tempdix
			;
			;     if (signe=='-')			// si la temprature est < 0
m014	MOVF  signe,W
	XORLW .45
	BTFSS 0x03,Zero_
	GOTO  m018
			;       {
			;	tempsig='-';
	MOVLW .45
	MOVWF tempsig
			;	tempdiz=0X35;		//0x35 = 5 en alphanumerique
	MOVLW .53
	MOVWF tempdiz
			;	tempuni=0X35;	
	MOVLW .53
	MOVWF tempuni
			;	cpt=0X92;		//-55C = 92
	MOVLW .146
	MOVWF cpt_2
			;	while (cpt < valeur) 	//decrementation de tempuni et tempdiz pour arriver  l'affichage correct
m015	MOVF  valeur,W
	SUBWF cpt_2,W
	BTFSC 0x03,Carry
	GOTO  m017
			;	{
			;	  cpt++;
	INCF  cpt_2,1
			;	  cpt++;
	INCF  cpt_2,1
			;	  tempuni--;
	DECF  tempuni,1
			;	  if (tempuni==0X2F)
	MOVF  tempuni,W
	XORLW .47
	BTFSS 0x03,Zero_
	GOTO  m016
			;	  {
			;		tempuni=0X39;
	MOVLW .57
	MOVWF tempuni
			;		tempdiz--;
	DECF  tempdiz,1
			;	  } 
			;	  if (cpt==0) cpt=0xff;		// correction pour le cas ou cpt est pass  0
m016	MOVF  cpt_2,1
	BTFSS 0x03,Zero_
	GOTO  m015
	MOVLW .255
	MOVWF cpt_2
			;	}
	GOTO  m015
			;	if (valeur<0x96)		// correction dans le cas ou temp < -50  (affichage de -)
m017	MOVLW .150
	SUBWF valeur,W
	BTFSC 0x03,Carry
	GOTO  m021
			;		{
			;		tempdix='-';
	MOVLW .45
	MOVWF tempdix
			;		tempuni='-';
	MOVLW .45
	MOVWF tempuni
			;		tempdiz='-';
	MOVLW .45
	MOVWF tempdiz
			;		tempsig=' ';
	MOVLW .32
	MOVWF tempsig
			;		}
			;       }
			;     else 				// si la temprature > 0 alors 
	GOTO  m021
			;	{
			;	 tempsig=' ';
m018	MOVLW .32
	MOVWF tempsig
			;	 tempdiz=0x30;			//0x30 = 0 en alphanumerique
	MOVLW .48
	MOVWF tempdiz
			;	 tempuni=0X30;
	MOVLW .48
	MOVWF tempuni
			;	 cpt=1;				// 0,5c = 1
	MOVLW .1
	MOVWF cpt_2
			;	 while (cpt < valeur)		//incrementation de tempuni et tempdiz pour arriver a l'affichage correct
m019	MOVF  valeur,W
	SUBWF cpt_2,W
	BTFSC 0x03,Carry
	GOTO  m021
			;	  {
			;	   cpt++;
	INCF  cpt_2,1
			;	   cpt++;
	INCF  cpt_2,1
			;	   tempuni++;
	INCF  tempuni,1
			;	   if (tempuni==0X3A)
	MOVF  tempuni,W
	XORLW .58
	BTFSS 0x03,Zero_
	GOTO  m020
			;	    {
			;		 tempuni=0X30;
	MOVLW .48
	MOVWF tempuni
			;		 tempdiz++;
	INCF  tempdiz,1
			;	    }
			;	   if (valeur>=0xC7)		// correction dans le cas ou temp > 100  (affichage de -)
m020	MOVLW .199
	SUBWF valeur,W
	BTFSS 0x03,Carry
	GOTO  m019
			;		{
			;		cpt=valeur;
	MOVF  valeur,W
	MOVWF cpt_2
			;		tempdix='-';
	MOVLW .45
	MOVWF tempdix
			;		tempuni='-';
	MOVLW .45
	MOVWF tempuni
			;		tempdiz='-';
	MOVLW .45
	MOVWF tempdiz
			;		tempsig=' ';
	MOVLW .32
	MOVWF tempsig
			;		}
			;	  }
	GOTO  m019
			;        }
			;lcd_goto(2);
m021	MOVLW .2
	CALL  lcd_goto
			;lcd_putch(tempsig);
	MOVF  tempsig,W
	CALL  lcd_putch
			;lcd_putch(tempdiz);
	MOVF  tempdiz,W
	CALL  lcd_putch
			;lcd_putch(tempuni);
	MOVF  tempuni,W
	CALL  lcd_putch
			;lcd_goto(6);
	MOVLW .6
	CALL  lcd_goto
			;lcd_putch(tempdix);
	MOVF  tempdix,W
	GOTO  lcd_putch
			;}
			;//------------------cration de caractres------------------------------
			;void lcd_create(void)
			;{
lcd_create
			;lcd_goto_cgram(0x08);
	MOVLW .8
	CALL  lcd_goto_cgram
			;lcd_puts("\x04\x0A\x11\x1F\x11\x15\x1F");	// une maison en 1
	CLRF  s
	CALL  lcd_puts
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_puts("\x0E\x1F\x1F\x0E\x14\x0D\x06");	// une fleur en 2
	MOVLW .8
	MOVWF s
	CALL  lcd_puts
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_puts("\x18\x18\x03\x04\x04\x04\x03");	// C en 3
	MOVLW .16
	MOVWF s
	CALL  lcd_puts
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_puts("\x08\x1c\x08");			// Valeur max en 4
	MOVLW .24
	MOVWF s
	CALL  lcd_puts
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);					// Valeur min en 5
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0x1c);
	MOVLW .28
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	CALL  lcd_putch
			;lcd_putch(0);
	MOVLW .0
	GOTO  lcd_putch
			;}
			;
			;//----------------- fonction principale----------------------------------
			;
			;void main()
			;{
main
			;				
			;initialisation();
	CALL  initialisation
			;temp_cfg_write(0b00000011);
	MOVLW .3
	CALL  temp_cfg_write
			;aft=0;				//affichage  l'initialisation
	BCF   0x03,RP0
	BCF   0x06,aft
			;lcd_init();
	CALL  lcd_init
			;lcd_clear();
	CALL  lcd_clear
			;lcd_create();
	CALL  lcd_create
			;
			;lcd_goto(0);			//affichage de la temprature interieure
	MOVLW .0
	CALL  lcd_goto
			;lcd_puts("\x01  --,-\x03");
	MOVLW .28
	MOVWF s
	CALL  lcd_puts
			;
			;while (1) 
			;{
			;clrwdt();
m022	CLRWDT
			;
			;//if (aft==1) sleep();		// si il n'y a pas d'affichage mettre le micro en sleep 
			;
			;if (titim==30)	temp_start();	// mise en fonction de la conversion de la temprature interieure
	MOVF  titim,W
	XORLW .30
	BTFSC 0x03,Zero_
	CALL  temp_start
			;
			;if (titim==31)			// rcupration de la temprature interieure et affichage si necessaire
	MOVF  titim,W
	XORLW .31
	BTFSS 0x03,Zero_
	GOTO  m024
			;    {
			;    temp_read();
	CALL  temp_read
			;    if (afeta==0b00010001) affichage(ti1,tisig);
	MOVF  afeta,W
	XORLW .17
	BTFSS 0x03,Zero_
	GOTO  m023
	MOVF  ti1,W
	MOVWF valeur
	MOVF  tisig,W
	CALL  affichage
			;    titim=0;
m023	CLRF  titim
			;    }
			;if (intext==1)			// si appui sur l'interrupteur et 300ms de pass 
m024	BCF   0x03,RP0
	BTFSS 0x05,intext
	GOTO  m027
			;    {
			;     if (timinter >= cinatt)
	MOVLW .60
	SUBWF timinter,W
	BTFSS 0x03,Carry
	GOTO  m027
			;	{
			;         timinter = 0 ;
	CLRF  timinter
			;	 if (afeta.4==0)	// si affichage invalide alors affichage
	BTFSC afeta,4
	GOTO  m025
			;	    {
			;	      aft=0;
	BCF   0x06,aft
			;	      lcd_init();
	CALL  lcd_init
			;	      lcd_clear();
	CALL  lcd_clear
			;	      lcd_create();
	CALL  lcd_create
			;	      lcd_goto(0);
	MOVLW .0
	CALL  lcd_goto
			;	      lcd_puts("\x01    , \x03");
	MOVLW .73
	MOVWF s
	CALL  lcd_puts
			;	      affichage(ti1,tisig);
	MOVF  ti1,W
	MOVWF valeur
	MOVF  tisig,W
	CALL  affichage
			;	      timaf=0;
	CLRF  timaf
			;	      afeta=0b00010001;	
	MOVLW .17
	MOVWF afeta
			;            }
			;	 else
	GOTO  m027
			;	    {
			;	      if (afeta.3==0)	//si affichage temprature interieure alors affichage temp exterieure 
m025	BTFSC afeta,3
	GOTO  m026
			;	       {
			;		lcd_goto(0);
	MOVLW .0
	CALL  lcd_goto
			;		lcd_puts("\x02    , \x03");
	MOVLW .82
	MOVWF s
	CALL  lcd_puts
			;		affichage(te1,tesig);
	MOVF  te1,W
	MOVWF valeur
	MOVF  tesig,W
	CALL  affichage
			;	        timaf=0;
	CLRF  timaf
			;		afeta=0b00011001;
	MOVLW .25
	MOVWF afeta
			;	       }
			;	      else		//si affichage temprature extrieure alors affichage temp int 
	GOTO  m027
			;	       {
			;		lcd_goto(0);
m026	MOVLW .0
	CALL  lcd_goto
			;		lcd_puts("\x01    , \x03");
	MOVLW .73
	MOVWF s
	CALL  lcd_puts
			;		affichage(ti1,tisig);
	MOVF  ti1,W
	MOVWF valeur
	MOVF  tisig,W
	CALL  affichage
			;		timaf=0;
	CLRF  timaf
			;		afeta=0b00010001;
	MOVLW .17
	MOVWF afeta
			;	       }
			;	   }
			;	}
			;    }
			;
			;if (minmax==0) timminmax=0;
m027	BCF   0x03,RP0
	BTFSS 0x05,minmax
	CLRF  timminmax
			;
			;if (minmax==1)
	BCF   0x03,RP0
	BTFSS 0x05,minmax
	GOTO  m022
			;    {
			;     if (timinter >= cinatt)
	MOVLW .60
	SUBWF timinter,W
	BTFSS 0x03,Carry
	GOTO  m022
			;	{
			;	 timminmax += 1;
	INCF  timminmax,1
			;         timinter = 0 ;
	CLRF  timinter
			;	 if (timminmax >= 5)	// le doigt est rest sur minmax donc effacement des min et max.
	MOVLW .5
	SUBWF timminmax,W
	BTFSS 0x03,Carry
	GOTO  m028
			;	  {
			;	    timin=ti1;
	MOVF  ti1,W
	MOVWF timin
			;	    timax=ti1;
	MOVF  ti1,W
	MOVWF timax
			;	    tisimin=tisig;
	MOVF  tisig,W
	MOVWF tisimin
			;	    tisimax=tisig;
	MOVF  tisig,W
	MOVWF tisimax
			;	    temin=te1;
	MOVF  te1,W
	MOVWF temin
			;	    temax=te1;
	MOVF  te1,W
	MOVWF temax
			;	    tesimin=tesig;
	MOVF  tesig,W
	MOVWF tesimin
			;	    tesimax=tesig;
	MOVF  tesig,W
	MOVWF tesimax
			;	  }
			;	if (afeta.1==1)		// si affichage max
m028	BTFSS afeta,1
	GOTO  m030
			;	    {
			;		if (afeta.3==0)		// si temp interieure alors affichage min interieur
	BTFSC afeta,3
	GOTO  m029
			;		{
			;	          lcd_goto(0);
	MOVLW .0
	CALL  lcd_goto
			;		  lcd_puts("\x01\x05   , \x03");
	MOVLW .37
	MOVWF s
	CALL  lcd_puts
			;		  affichage(timin,tisimin);
	MOVF  timin,W
	MOVWF valeur
	MOVF  tisimin,W
	CALL  affichage
			;	          timaf=0;
	CLRF  timaf
			;		  afeta.1=0;
	BCF   afeta,1
			;		  afeta.2=1;
	BSF   afeta,2
			;		}
			;		if (afeta.3==1)		// si temp exterieure alors affichage min exterieur
m029	BTFSS afeta,3
	GOTO  m022
			;		{
			;	          lcd_goto(0);
	MOVLW .0
	CALL  lcd_goto
			;		  lcd_puts("\x02\x05   , \x03");
	MOVLW .46
	MOVWF s
	CALL  lcd_puts
			;		  affichage(temin,tesimin);
	MOVF  temin,W
	MOVWF valeur
	MOVF  tesimin,W
	CALL  affichage
			;	          timaf=0;
	CLRF  timaf
			;		  afeta.1=0;
	BCF   afeta,1
			;		  afeta.2=1;
	BSF   afeta,2
			;		}
			;	    }
			;
			;	 else
	GOTO  m022
			;	   {
			;	    if (afeta.0==1)		// si affichage present
m030	BTFSS afeta,0
	GOTO  m032
			;	    {
			;		if (afeta.3==0)		// si temp interieure alors affichage max interieur
	BTFSC afeta,3
	GOTO  m031
			;		{
			;	          lcd_goto(0);
	MOVLW .0
	CALL  lcd_goto
			;		  lcd_puts("\x01\x04   , \x03");
	MOVLW .55
	MOVWF s
	CALL  lcd_puts
			;		  affichage(timax,tisimax);
	MOVF  timax,W
	MOVWF valeur
	MOVF  tisimax,W
	CALL  affichage
			;	          timaf=0;
	CLRF  timaf
			;		  afeta.0=0;
	BCF   afeta,0
			;		  afeta.1=1;
	BSF   afeta,1
			;		}
			;		if (afeta.3==1)		// si temp exterieure alors affichage max exterieur
m031	BTFSS afeta,3
	GOTO  m022
			;		{
			;	          lcd_goto(0);
	MOVLW .0
	CALL  lcd_goto
			;		  lcd_puts("\x02\x04   , \x03");
	MOVLW .64
	MOVWF s
	CALL  lcd_puts
			;		  affichage(temax,tesimax);
	MOVF  temax,W
	MOVWF valeur
	MOVF  tesimax,W
	CALL  affichage
			;	          timaf=0;
	CLRF  timaf
			;		  afeta.0=0;
	BCF   afeta,0
			;		  afeta.1=1;
	BSF   afeta,1
			;		}
			;	    }
			;	    else			// si affichage min
	GOTO  m022
			;	    {
			;		if (afeta.3==0)		// si temp interieure alors affichage present interieur
m032	BTFSC afeta,3
	GOTO  m033
			;		{
			;	          lcd_goto(0);
	MOVLW .0
	CALL  lcd_goto
			;		  lcd_puts("\x01    , \x03");
	MOVLW .73
	MOVWF s
	CALL  lcd_puts
			;		  affichage(ti1,tisig);
	MOVF  ti1,W
	MOVWF valeur
	MOVF  tisig,W
	CALL  affichage
			;	          timaf=0;
	CLRF  timaf
			;		  afeta.2=0;
	BCF   afeta,2
			;		  afeta.0=1;
	BSF   afeta,0
			;		}
			;		if (afeta.3==1)		// si temp exterieure alors affichage present exterieur
m033	BTFSS afeta,3
	GOTO  m022
			;		{
			;	          lcd_goto(0);
	MOVLW .0
	CALL  lcd_goto
			;		  lcd_puts("\x02    , \x03");
	MOVLW .82
	MOVWF s
	CALL  lcd_puts
			;		  affichage(te1,tesig);
	MOVF  te1,W
	MOVWF valeur
	MOVF  tesig,W
	CALL  affichage
			;	          timaf=0;
	CLRF  timaf
			;		  afeta.2=0;
	BCF   afeta,2
			;		  afeta.0=1;
	BSF   afeta,0
			;		}
			;	    }
			;	   }
			;	}	
			;
			;    }
			;}
	GOTO  m022

	END


; *** KEY INFO ***
; RAM usage: 32 bytes (9 local), 36 bytes free
; Maximum call level: 3 (+1 for interrupt)
; Total of 823 code words (80 %)

;    28 word(s),  1 %: interruption
;    43 word(s),  2 %: initialisation
;    10 word(s),  0 %: delay_5ms
;    12 word(s),  0 %: delay_10us
;    19 word(s),  0 %: lcd_write_fast
;     6 word(s),  0 %: lcd_clear
;    13 word(s),  0 %: lcd_puts
;    99 word(s),  4 %: _const1
;     5 word(s),  0 %: lcd_putch
;     6 word(s),  0 %: lcd_goto
;     6 word(s),  0 %: lcd_goto_cgram
;    33 word(s),  1 %: lcd_init
;    54 word(s),  2 %: temp_write_8bits
;    45 word(s),  2 %: temp_read_8bits
;    10 word(s),  0 %: temp_cfg_write
;     7 word(s),  0 %: temp_start
;    70 word(s),  3 %: temp_read
;   102 word(s),  4 %: affichage
;    45 word(s),  2 %: lcd_create
;   209 word(s), 10 %: main
